<?php
/**
 * @package All-in-One-SEO-Pack 
 */
/**
 * The Opengraph class.
 */
if ( !class_exists( 'All_in_One_SEO_Pack_Opengraph' ) ) {
	class All_in_One_SEO_Pack_Opengraph extends All_in_One_SEO_Pack_Module {

		function All_in_One_SEO_Pack_Opengraph( ) {
			$this->name = __('Social Meta', 'all_in_one_seo_pack');	// Human-readable name of the plugin
			$this->prefix = 'aiosp_opengraph_';						// option prefix
			$this->file = __FILE__;									// the current file
			parent::__construct();
			$categories = Array( 'blog' => 'blog', 'website' => 'website' );
			$fbtypes = Array(
				'Activities' => Array(
					'activity' => __( 'Activity', 'all_in_one_seo_pack' ),
					'sport' => __( 'Sport', 'all_in_one_seo_pack' )
				),
				'Businesses' => Array(
					'bar' => __( 'Bar', 'all_in_one_seo_pack' ),
					'company' => __( 'Company', 'all_in_one_seo_pack' ),
					'cafe' => __( 'Cafe', 'all_in_one_seo_pack' ),
					'hotel' => __( 'Hotel', 'all_in_one_seo_pack' ),
					'restaurant' => __( 'Restaurant', 'all_in_one_seo_pack' )
				),
				'Groups' => Array(
					'cause' => __( 'Cause', 'all_in_one_seo_pack' ),
					'sports_league' => __( 'Sports League', 'all_in_one_seo_pack' ),
					'sports_team' => __( 'Sports Team', 'all_in_one_seo_pack' )
				),
				'Organizations' => Array(
					'band' => __( 'Band', 'all_in_one_seo_pack' ),
					'government' => __( 'Government', 'all_in_one_seo_pack' ),
					'non_profit' => __( 'Non Profit', 'all_in_one_seo_pack' ),
					'school' => __( 'School', 'all_in_one_seo_pack' ),
					'university' => __( 'University', 'all_in_one_seo_pack' )
				),
				'People' => Array(
					'actor' => __( 'Actor', 'all_in_one_seo_pack' ),
					'athlete' => __( 'Athlete', 'all_in_one_seo_pack' ),
					'author' => __( 'Author', 'all_in_one_seo_pack' ),
					'director' => __( 'Director', 'all_in_one_seo_pack' ),
					'musician' => __( 'Musician', 'all_in_one_seo_pack' ),
					'politician' => __( 'Politician', 'all_in_one_seo_pack' ),
					'profile' => __( 'Profile', 'all_in_one_seo_pack' ),
					'public_figure' => __( 'Public Figure', 'all_in_one_seo_pack' )
				),
				'Places' => Array(
					'city' => __( 'City', 'all_in_one_seo_pack' ),
					'country' => __( 'Country', 'all_in_one_seo_pack' ),
					'landmark' => __( 'Landmark', 'all_in_one_seo_pack' ),
					'state_province' => __( 'State Province', 'all_in_one_seo_pack' )
				),
				'Products and Entertainment' => Array(
					'album' => __( 'Album', 'all_in_one_seo_pack' ),
					'book' => __( 'Book', 'all_in_one_seo_pack' ),
					'drink' => __( 'Drink', 'all_in_one_seo_pack' ),
					'food' => __( 'Food', 'all_in_one_seo_pack' ),
					'game' => __( 'Game', 'all_in_one_seo_pack' ),
					'movie' => __( 'Movie', 'all_in_one_seo_pack' ),
					'product' => __( 'Product', 'all_in_one_seo_pack' ),
					'song' => __( 'Song', 'all_in_one_seo_pack' ),
					'tv_show' => __( 'TV Show', 'all_in_one_seo_pack' )
				),'Websites' => Array(
					'article' => __( 'Article', 'all_in_one_seo_pack' ),
					'blog' => __( 'Blog', 'all_in_one_seo_pack' ),
					'website' => __( 'Website', 'all_in_one_seo_pack' )
				)
			);
			
			$this->default_options = array(
					'scan_header'=> Array( 'name' => __( 'Scan Header', 'all_in_one_seo_pack' ), 'type' => 'custom', 'save' => true ),
					'setmeta'		=> Array( 	'name'			=> __( 'Use AIOSEO Title and Description:',  'all_in_one_seo_pack'),
										  		'help_text'		=> __( 'Checking this box ensures that the title and description used in the All in One general settings will be used for the title and description for the Facebook Open Graph meta values', 'all_in_one_seo_pack'),
					 					  		'default'		=> '', 'type' => 'checkbox' ),
					'key'			=> Array( 	'name'			=> __( 'Profile Admins ID',  'all_in_one_seo_pack'),
										  		'help_text'		=> __( 'Your Profile Admins ID is your facebook profile identification number. You can find out your Facebook id using the following tool: "https://graph.facebook.com/yourusername."', 'all_in_one_seo_pack'),
					 					  		'default'		=> '', 'type' => 'text' ),
					'sitename'		=> Array( 	'name'			=> __( 'Site Name',  'all_in_one_seo_pack'),
												'help_text'		=> __( 'The "Site Name" is the name that allows users to identify your website.', 'all_in_one_seo_pack'),
												'default'		=> get_bloginfo('name'), 'type' => 'text' ),
					'hometitle' 	=> Array(	'name'			=> __( 'Home Title',  'all_in_one_seo_pack'),
												'help_text'		=> __( 'The Home Title is the title as it appears on the homepage of your website.', 'all_in_one_seo_pack'),
												'default'		=> '', 'type' => 'textarea' ),
					'description' 	=> Array(	'name'			=> __( 'Home Description',  'all_in_one_seo_pack'),
												'help_text'		=> __( 'The Home Description is the description as it appears on the homepage of your website.', 'all_in_one_seo_pack'),
												'default'		=> '', 'type' => 'textarea' ),
					'generate_descriptions' => Array(
												'name'			=> __( 'Autogenerate Descriptions:', 'all_in_one_seo_pack' ),
												'help_text'		=> __( "Check this and your social post descriptions will get autogenerated if there's no description provided.", 'all_in_one_seo_pack' ),
												'default'		=> 1 ),
					'dimg' 			=> Array(	'name'			=> __( 'Default Image',  'all_in_one_seo_pack'),
												'help_text'		=> __( 'This option sets the url for the default site thumbnail on pages or posts that do not have a thumbnail set.', 'all_in_one_seo_pack'),
												'default'		=> AIOSEOP_PLUGIN_IMAGES_URL . 'default-user-image.png', 'type' => 'image' ),
					'categories' 	=> Array( 	'name'	  		=> __( 'Facebook Object Type', 'all_in_one_seo_pack'),
												'help_text' 	=> __( 'Please identify your website as a weblog or a content website', 'all_in_one_seo_pack'),
												'type'			=> 'radio', 'initial_options' => $categories,
												'default'		=> 'blog' ),
					'types' 		=> Array( 	'name'	  		=> __( 'Enable Facebook Meta for', 'all_in_one_seo_pack'),
												'help_text' 	=> __( 'Enables Facebook Open Graph meta values for posts that feature these post types.', 'all_in_one_seo_pack' ),
												'type'			=> 'multicheckbox', 'initial_options' => $this->get_post_type_titles( Array( '_builtin' => false ) ),
												'default'		=> Array( 'post' => 'post', 'page' => 'page' ) ),
					'title' 		=> Array(	'name'			=> __( 'Title',  'all_in_one_seo_pack'),
												'help_text'		=> __( 'This sets the meta value for the title of your post', 'all_in_one_seo_pack'),
												'default'		=> '', 'type' => 'text', 'size' => 60, 'count' => 1 ),
					'desc'			=> Array(	'name'			=> __( 'Description',  'all_in_one_seo_pack'),
												'help_text'		=> __( 'This sets the meta value for the description of your post', 'all_in_one_seo_pack'),
												'default'		=> '', 'type' => 'textarea', 'cols' => 80, 'rows' => 2, 'count' => 1 ),
					'category'		=> Array(	'name'	  		=> __( 'Facebook Object Type', 'all_in_one_seo_pack'),
												'help_text' 	=> __( 'Choose a value that best describes the content of your post.', 'all_in_one_seo_pack'),
												'type'			=> 'select',
												'style'	  		=> '',
												'initial_options' => $fbtypes,
												'default'		=> 'article'
										)
			);
			
			// load initial options / set defaults
			$this->update_options( );

			$display = Array();
			if ( isset( $this->options['aiosp_opengraph_types'] ) ) $display = $this->options['aiosp_opengraph_types'];

			$this->locations = array(
				'opengraph'	=> 	Array( 'name' => $this->name, 'prefix' => 'aiosp_', 'type' => 'settings', 
									   'options' => Array('scan_header', 'setmeta', 'key', 'sitename', 'hometitle', 'description', 'generate_descriptions', 'dimg', 'categories', 'types') ),
				'settings'	=>	Array(	'name'		=> __('Social Settings', 'all_in_one_seo_pack'),
														  'type'		=> 'metabox',
														  'options'	=> Array( 'title', 'desc', 'category' ),
														  'display' => $display, 'prefix' => 'aioseop_opengraph_'
									)
			);
			
			$this->layout = Array(
				'default' => Array(
						'name' => __( 'Social Meta', 'all_in_one_seo_pack' ),
						'options' => Array() // this is set below, to the remaining options -- pdb
					),
				'scan_meta'  => Array(
						'name' => __( 'Scan Social Meta', 'all_in_one_seo_pack' ),
						'options' => Array( 'scan_header' )
					)
			);
			
			$other_options = Array();
			foreach( $this->layout as $k => $v )
				$other_options = array_merge( $other_options, $v['options'] );
			
			$this->layout['default']['options'] = array_diff( array_keys( $this->default_options ), $other_options );
			

			
			add_action( 'admin_init', Array( $this, 'debug_post_types' ), 5 );	
			if( !is_admin() ){ $this->do_opengraph(); }
		}
		
		function settings_page_init() {
			add_filter( $this->prefix . 'display_settings', Array( $this, 'filter_settings' ), 10, 3 );
			add_filter( 'aiosp_output_option', Array( $this, 'display_custom_options' ), 10, 2 );
		}
		
		function filter_settings( $settings, $location, $current ) {
			if ( $location == 'opengraph' || $location == 'settings' ) {
				if ( $location == 'opengraph' ) $opts = Array( 'hometitle', 'description' );
				if ( $location == 'settings'  ) $opts = Array( 'title', 'desc' );
				$prefix = $this->get_prefix( $location ) . $location . '_';
				if ( isset( $current[ $prefix . 'setmeta' ] ) && $current[ $prefix . 'setmeta' ] )
					foreach ( $opts as $opt )
						if ( isset( $settings[ $prefix . $opt ] ) ) {
							$settings[ $prefix . $opt ]['type'] = 'hidden';
							$settings[ $prefix . $opt ]['label'] = 'none';
							$settings[ $prefix . $opt ]['help_text'] = '';
						}
			}
			return $settings;
		}
		
		/** Custom settings **/
		function display_custom_options( $buf, $args ) {
			if ( $args['name'] == 'aiosp_opengraph_scan_header' ) {
				$buf .= '<div class="aioseop aioseop_options aiosp_opengraph_settings"><div class="aioseop_wrapper aioseop_custom_type" id="aiosp_opengraph_scan_header_wrapper"><div class="aioseop_input" id="aiosp_opengraph_scan_header" style="padding-left:20px;">';
				$args['options']['type'] = 'submit';
				$args['attr'] = " class='button-primary' ";
				$args['value'] = $args['options']['default'] = __( 'Scan Now', 'all_in_one_seo_pack' );
//				$args['options']['default'] = "Scan Headers: <input name='Scan_Submit' type='submit'>";
			}
			$buf .= __( 'Scan your site for duplicate social meta tags.', 'all_in_one_seo_pack' );
			$buf .= '<br /><br />' . $this->get_option_html( $args );
			$buf .= '</div></div></div>';
			return $buf;
		}

		function add_attributes( $output ) { // avoid having duplicate meta tags
			/*
			remove_action( 'wp_head', 'jetpack_og_tags' );
			global $wpseo_og, $wpseo_twitter;
			if ( is_object( $wpseo_og ) ) {
				remove_action( 'wpseo_head', array( $wpseo_og, 'opengraph' ) );
				remove_action( 'wpseo_head', array( $wpseo_og, 'wpseo_opengraph_action' ) );				
			}
			if ( is_object( $wpseo_twitter ) ) {
				remove_action( 'wpseo_head', array( $wpseo_twitter, 'twitter' ) );
			}
			*/
			return $output . 'xmlns="http://www.w3.org/1999/xhtml"
			      xmlns:og="http://ogp.me/ns#"
			      xmlns:fb="http://www.facebook.com/2008/fbml"';
		}
		
		function add_meta( ) {
			
			global $post, $aiosp, $aioseop_options, $wp_query;
			$metabox = $this->get_current_options( Array(), 'settings' );
			$key = $this->options['aiosp_opengraph_key'];
			$dimg = $this->options['aiosp_opengraph_dimg'];
			$current_post_type = get_post_type();
			
			$sitename = $this->options['aiosp_opengraph_sitename'];
			
			if ( !empty( $aioseop_options['aiosp_hide_paginated_descriptions'] ) ) {
				$first_page = false;
				if ( $aiosp->get_page_number() < 2 ) $first_page = true;				
			} else {
				$first_page = true;
			}
			$url = $aiosp->aiosp_mrt_get_url( $wp_query );
			
			if ( is_home( ) || $aiosp->is_static_front_page() ) {
				$setmeta = $this->options['aiosp_opengraph_setmeta'];
				$title = $this->options['aiosp_opengraph_hometitle'];
				if ( $first_page )
					$description = $this->options['aiosp_opengraph_description'];
				$type = $this->options['aiosp_opengraph_categories'];
				$thumbnail = $this->options['aiosp_opengraph_dimg'];
				
				/* If Use AIOSEO Title and Desc Selected */
				if( $setmeta ){
					$title = $aioseop_options['aiosp_home_title'];
					if ( $first_page )
						$description = $aioseop_options['aiosp_home_description'];
				}
				
				/* Add some defaults */
				if( empty($title) ) $title = get_bloginfo('name');
				if( empty($sitename) ) $sitename = get_bloginfo('name');
				
				if ( empty( $description ) && $first_page && ( !empty( $this->options['aiosp_opengraph_generate_descriptions'] ) ) )
					$description = $aiosp->trim_excerpt_without_filters( $aiosp->internationalize( $post->post_content ) );
				
				if( empty($description) && $first_page ) $description = get_bloginfo('description');
				
			} elseif( is_singular( ) && $this->option_isset('types') 
						&& is_array( $this->options['aiosp_opengraph_types'] ) 
						&& in_array( $current_post_type, $this->options['aiosp_opengraph_types'] ) ) {
				if ( isset( $metabox['aioseop_opengraph_settings_category'] ) ) $type    = $metabox['aioseop_opengraph_settings_category'];
				if ( isset( $metabox['aioseop_opengraph_settings_setmeta'] ) )  $setmeta = $metabox['aioseop_opengraph_settings_setmeta'];
				
				/* Add AIOSEO variables if Site Title and Desc from AIOSEOP not selected */
				if( !empty( $setmeta ) ){
					$title = get_post_meta( $post->ID, '_aioseop_title', true );
					if ( $first_page )
						$description = get_post_meta( $post->ID, '_aioseop_description', true );
				} else {
					$title = $metabox['aioseop_opengraph_settings_title'];
					if ( $first_page )
						$description = $metabox['aioseop_opengraph_settings_desc'];
				}
				
				/* Add some defaults */
				if( empty( $title ) ) $title = get_the_title();
				if ( empty( $description ) && $first_page && ( $this->options['aiosp_opengraph_generate_descriptions'] ) )
					$description = $aiosp->trim_excerpt_without_filters( $aiosp->internationalize( $post->post_content ) );
				if( empty( $type )  ) $type = 'article';
				
			} else return;
			
			/* Data Validation */
			$title = stripcslashes( esc_html( $title ) );
			$sitename = stripcslashes( esc_html( $sitename ) );
			$description = stripcslashes( esc_html( $description ) );
			
			/* Get the first image attachment on the post */
			if( empty($thumbnail) ) $thumbnail = $this->get_the_image(); 
			
			/* Add user supplied default image */
			if( empty($thumbnail) ) $thumbnail = $this->options['aiosp_opengraph_dimg'];
			
			$card = 'summary';
			
			/* OG only: */
			$meta = Array(
				'facebook'	=> Array(
						'title'			=> 'og:title',
						'type'			=> 'og:type',
						'url'			=> 'og:url',
						'thumbnail'		=> 'og:image',
						'sitename'		=> 'og:site_name',
						'key'			=> 'fb:admins',
						'description'	=> 'og:description'
					),
				'twitter'	=> Array(
						'card'			=> 'twitter:card',
						'description'	=> 'twitter:description',
					)
			);
			
			// Add links to testing tools
			
			/*
			http://developers.facebook.com/tools/debug
			https://dev.twitter.com/docs/cards/preview
			http://www.google.com/webmasters/tools/richsnippets
			*/
			/*
			$meta = Array(
				'facebook'	=> Array(
						'title'			=> 'og:title',
						'type'			=> 'og:type',
						'url'			=> 'og:url',
						'thumbnail'		=> 'og:image',
						'sitename'		=> 'og:site_name',
						'key'			=> 'fb:admins',
						'description'	=> 'og:description'
					),
				'google+'	=> Array(
						'thumbnail'		=> 'image',
						'title'			=> 'name',
						'description'	=> 'description'
					),
				'twitter'	=> Array(
						'card'			=> 'twitter:card',
						'url'			=> 'twitter:url',
						'title'			=> 'twitter:title',
						'description'	=> 'twitter:description',
						'thumbnail'		=> 'twitter:image'
						
					)
			);
			*/
			
			/*
				Note -- add support for these too, as per https://dev.twitter.com/docs/cards
				
				Card Property	Description	Required
				twitter:site	@username for the website used in the card footer.	No
				twitter:site:id	Same as twitter:site, but the website's Twitter user ID instead. Note that user ids never change, while @usernames can be changed by the user.	No
				twitter:creator	@username for the content creator / author.	No
				twitter:creator:id	Same as twitter:creator, but the Twitter user's ID.	No
			*/
			
			$tags = Array(
					'facebook'	=> Array( 'name' => 'property', 'value' => 'content' ),
					'twitter'	=> Array( 'name' => 'name', 'value' => 'value' ),
					'google+'	=> Array( 'name' => 'itemprop', 'value' => 'content' )
			);
			
			foreach ( $meta as $t => $data )
				foreach ( $data as $k => $v )
					if ( !empty( $$k ) ) echo '<meta ' . $tags[$t]['name'] . '="' . $v . '" ' . $tags[$t]['value'] . '="' . $$k . '" />' . "\n";
			
			/*
			echo "<meta property=\"og:title\" content=\"$title\" />\n";
			echo "<meta property=\"og:type\" content=\"$type\" />\n";
			echo "<meta property=\"og:url\" content=\"$url\" />\n";
			echo "<meta property=\"og:image\" content=\"" . $thumbnail . "\" />\n";
			echo "<meta property=\"og:site_name\" content=\"$sitename\" />\n";
			echo "<meta property=\"fb:admins\" content=\"$key\" />\n";
			echo "<meta property=\"og:description\" content=\"$description\" />\n";
			
			echo '<meta name="twitter:card" value="summary" />' . "\n";
			echo "<meta name=\"twitter:url\" value=\"$url\" />\n";
			echo "<meta name=\"twitter:title\" value=\"$title\" />\n";
			echo "<meta name=\"twitter:description\" value=\"$description\" />\n";
			echo "<meta name=\"twitter:image\" value=\"$thumbnail\" />\n";
			
			echo "<meta itemprop=\"image\" content=\"$thumbnail\">\n";
			echo "<meta itemprop=\"name\" content=\"$title\">\n";
			echo "<meta itemprop=\"description\" content=\"$description\">\n";
			*/
		}
		
		function do_opengraph( ) {
			add_filter( 'language_attributes', Array( $this, 'add_attributes' ) );
			add_action( 'aioseop_modules_wp_head', Array( $this, 'add_meta' ), 5 );	
		}
		
		function debug_post_types( ) {
			$post_types = $this->get_post_type_titles( );
			$rempost = array( 'attachment' => 1, 'revision' => 1, 'nav_menu_item' => 1 );
			$this->default_options['types']['initial_options']  = array_diff_key( $post_types, $rempost );
		}
		
		function get_the_image( ) {
			if ( empty( $image ) ) $image = $this->get_the_image_by_post_thumbnail( );
			if ( empty( $image ) ) $image = $this->get_the_image_by_attachment( );
			if ( empty( $image ) ) $image = $this->get_the_image_by_scan( );
			if ( empty( $image ) ) $image = $this->get_the_image_by_default( );
			return $image;
		}
		
		function get_the_image_by_post_thumbnail( ) {

			global $post;

			$post_thumbnail_id = null;
			if ( function_exists('get_post_thumbnail_id' ) ) {
				$post_thumbnail_id = get_post_thumbnail_id( $post->ID );				
			}
			
			if ( empty( $post_thumbnail_id ) ) 
				return false;
			
			$size = apply_filters( 'post_thumbnail_size', 'thumbnail' );
			$image = wp_get_attachment_image_src( $post_thumbnail_id, $size ); 
				return $image[0];
				
		}
		
		function get_the_image_by_attachment( $args = array() ) {

			global $post;
			$attachments = get_children( Array( 'post_parent' 		=> $post->ID, 
												'post_status' 		=> 'inherit', 
												'post_type' 		=> 'attachment', 
												'post_mime_type'	=> 'image', 
												'order' 			=> 'ASC', 
												'orderby' 			=> 'menu_order ID' ) );
												
			if ( empty( $attachments ) ) {
				if ( 'attachment' == get_post_type( $post->ID ) ) {
					$image = wp_get_attachment_image_src( $post->ID, 'thumbnail' );
				}
			}

			/* If no attachments or image is found, return false. */
			if ( empty( $attachments ) && empty( $image ) )
				return false;

			/* Set the default iterator to 0. */
			$i = 0;

			/* Loop through each attachment. Once the $order_of_image (default is '1') is reached, break the loop. */
			foreach ( $attachments as $id => $attachment ) {
				if ( ++$i == 1 ) {
					$image = wp_get_attachment_image_src( $id, 'thumbnail' );
					$alt = trim( strip_tags( get_post_field( 'post_excerpt', $id ) ) );
					break;
				}
			}
			
			/* Return the image URL. */
			return $image[0];
			
		}
		
		function get_the_image_by_scan( ) {
			
			global $post;
			
			/* Search the post's content for the <img /> tag and get its URL. */
			preg_match_all( '|<img.*?src=[\'"](.*?)[\'"].*?>|i', get_post_field( 'post_content', $post->ID ), $matches );

			/* If there is a match for the image, return its URL. */
			if ( isset( $matches ) && !empty( $matches[1][0] ) )
				return $matches[1][0];

			return false;
			
		}
		
		function get_the_image_by_default( $args = array() ) {
			return $this->options['aiosp_opengraph_dimg'];
		}
		
		function settings_update( ) {
			
		}
	}
}
